import * as Mqtt from 'mqtt'

class MqttMongo {
  private mqttClient : Mqtt.Client

  constructor() {
  }

  exec(): void {
    this.mqttClient = Mqtt.connect(options['broker'])
    this.mqttClient.on('connect', () => {
      console.log("connected to broker")
      this.mqttClient.subscribe('MqttMongo/Command')
      this.mqttClient.publish('MqttMongo/Status', 'hello, started up')
    })
    this.mqttClient.on('message', (topic : string, message : string) => {
      console.log("message received")
      console.log("topic %s", topic)
      console.log("message %s", message)

      if (topic == "MqttMongo/Command" && message == "shutdown") {
        this.mqttClient.end()
      }
    })
    this.mqttClient.on('close', () => {
      console.log("bye bye")
    })

    console.log("Hello world")
  }
}


import options = require('commander')
options
  .version('0.0.1')
  .option('-b, --broker [broker url]', 'Broker URL', 'mqtt://mqttbroker')
  .parse(process.argv)

const mqttMongo = new MqttMongo()
mqttMongo.exec()